<?php
// $Id: xc_search_display_template_element.php,v 1.1.2.6 2009/12/16 15:00:37 mtwesley Exp $

function xc_search_display_template_element_get($entity_type, $element_name = NULL) {
  static $template_element_cache;
  if (!isset($template_element_cache)) {
    $template_element_cache = array();
  }
  $key = isset($element_name) ? $element_name : 'ANY';
  
  if (!isset($template_element_cache[$entity_type]) 
    || !isset($template_element_cache[$entity_type][$key])) {
    $sql = "SELECT element_name, template FROM {xc_search_display_template_element} 
      WHERE entity_type = '%s'";
    if ($element_name != NULL) {
      $sql = " AND element_name = '%s'";
      $result = db_query(db_rewrite_sql($sql, '{xc_search_display_template_element}',
        'element_id'), $entity_type, $element_name);
    }
    else {
      $result = db_query(db_rewrite_sql($sql, '{xc_search_display_template_element}',
        'element_id'), $entity_type);
    }
    $val = NULL;
    if ($element_name != NULL) {
      $data = db_fetch_object($result);
      $val = $data->template;
    }
    else {
      $val = array();
      while ($data = db_fetch_object($result)) {
        $val[$data->element_name] = $data->template;
      }
    }
    $template_element_cache[$entity_type][$key] = $val;
  }
  return $template_element_cache[$entity_type][$key];
}

function xc_search_display_template_element_load($xc_search_display_template_element) {
  $sql = "SELECT * FROM {xc_search_display_template_element} WHERE element_id = %d";
  $result = db_query(db_rewrite_sql($sql, '{xc_search_display_template_element}',
    'element_id'), $xc_search_display_template_element);
  $data = db_fetch_object($result);
  return $data;
} 

function xc_search_display_template_element_title($record) {
  return t('Display template element');
}

function xc_search_display_template_element_fieldset() {
  return array(
    'metadata_schema' => t('metadata schema'), 
    'entity_type'     => t('entity type'),
    'element_name'    => t('element name'), 
    'template'        => t('element template'),
  );
}

function xc_search_display_template_element_options() {
  $options = array('metadata_schema' => array());
  
  // metadata schema
  $options['metadata_schema'] = xc_format_get_schemas();
  
  // entities
  $options['entity_type'] = xc_format_get_entities();
  
  return $options;
}

function xc_search_display_template_element_view($record) {
  return xc_util_view($record, 
    xc_search_display_template_element_fieldset(),
    xc_search_display_template_element_options(),
    array('filters' => array('template' => array('htmlentities', 'nl2br')))
  );
}

function xc_search_display_template_element_list() {
  $headers = array(t('Schema'), t('Entity'), t('Element'), t('Template'));
  $rows = array();
  $options = xc_search_display_template_element_options();
  $sql = "SELECT * FROM {xc_search_display_template_element}";
  $result = db_query(db_rewrite_sql($sql, '{xc_search_display_template_element}',
    'element_id'));
  while ($data = db_fetch_object($result)) {
    $rows[] = array(
      $data->metadata_schema,
      $data->entity_type,
      l($data->element_name, 'xc/search/displaying/display_template_element/'.$data->element_id),
      nl2br(htmlentities($data->template)) 
    );
  }
  return theme('table', $headers, $rows);
}

function xc_search_display_template_element_add() {
  drupal_set_title('Create a new template element');
  return drupal_get_form('xc_search_display_template_element_form');
}

function xc_search_display_template_element_form() {
  $schema = drupal_get_schema_unprocessed('xc_search', 'xc_search_display_template_element');
  drupal_set_title($schema['description']);
  $options = array(
    'omit' => array('element_id'),
    'hidden' => array(),
    'label' => xc_search_display_template_element_fieldset(),
    'select' => xc_search_display_template_element_options(),
  // TODO: metadata_schema!!!
  );
  
  $form = xc_util_build_autoform($schema, $options);
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
  );

  return $form;
}

function xc_search_display_template_element_edit_form($form_state, $record) {
  $form = xc_search_display_template_element_form($form_state, $record);
  $form['element_id'] = array(
    '#type'  => 'hidden',
    '#value' => $record->element_id,
  );
  
  foreach (xc_search_display_template_element_fieldset() as $name => $label) {
    $form[$name]['#default_value'] = $record->$name;
  }
    
  $form['submit']['#value'] = t('Save');
  $form['delete'] = array(
    '#type'  => 'submit',
    '#value' => t('Delete'),
  );

  return $form;
}

function xc_search_display_template_element_form_submit($form, &$form_state) {
  $values = $form_state['values'];
  $record = new stdClass();
  foreach (xc_search_display_template_element_fieldset() as $name => $label) {
    $record->$name = $values[$name];
  }

  $ret_val = drupal_write_record('xc_search_display_template_element', $record);
  if ($ret_val == SAVED_NEW) {
    drupal_set_message(t('Successfully added "%name" display template element!',
                         array('%name' => $record->element_name)));
    $form_state['redirect'] = 'xc/search/displaying/display_template_element/' . $record->element_id . '/view';
  }
  else {
    drupal_set_message(t('Unexpected error. Failed to create new display template element.'));
  }
}

function xc_search_display_template_element_edit_form_submit($form, &$form_state) {
  $values = $form_state['values'];
  $record = new stdClass();
  $record->element_id             = $values['element_id'];
  foreach (xc_search_display_template_element_fieldset() as $name => $label) {
    $record->$name = $values[$name];
  }
    
  if ($form_state['clicked_button']['#value'] == t('Delete')) {
    $sql = "DELETE FROM {xc_search_display_template_element} WHERE element_id = %d";
    $result = db_query(db_rewrite_sql($sql, '{xc_search_display_template_element}',
      'element_id'), $record->element_id);

    if ($result == SAVED_DELETED) { // element is deleted
      drupal_set_message(t('%name removed', array('%name' => $record->element_name)));
      $form_state['redirect'] = 'xc/search/displaying/display_template_element/list';
    }
    else {
      drupal_set_message(t('Unexpected error. Failed to remove display template.'));
    }
  }
  else {
    $ret_val = drupal_write_record('xc_search_display_template_element', $record, 'element_id');
    if ($ret_val == SAVED_UPDATED) {
      drupal_set_message(t('Successfully updated "%name" display template element!',
                         array('%name' => $record->element_name)));
      $form_state['redirect'] = 'xc/search/displaying/display_template_element/' . $record->element_id . '/view';
    }
    else {
      drupal_set_message(t('Unexpected error. Failed modify display template element.'));
    }
  }
}

