<?php
// $Id: xc_search_facet_field.php,v 1.1.2.8 2009/12/16 15:00:37 mtwesley Exp $

function xc_search_facet_field_load($field_id) {
  $sql = "SELECT * FROM {xc_search_facet_field} WHERE field_id = %d";
  $result = db_query(db_rewrite_sql($sql, '{xc_search_facet_field}', 'field_id'), 
    $field_id);
  $data = db_fetch_object($result);
  return $data;
} 

function xc_search_facet_field_edit_load($field_id) {
  return xc_search_facet_field_load($field_id);
}

function xc_search_facet_field_fieldset() {
  return array(
    'name' => t('name'),
    'type' => t('facet type'),
    'facet_id' => t('facet'),
    'attribute_set_id' => t('attribute set')
  );
}

function xc_search_facet_field_form($form_state, $facet) {
  $schema = drupal_get_schema_unprocessed('xc_search', 'xc_search_facet_field');
  drupal_set_title($schema['description']);
  $options = array(
    'omit' => array('field_id'),
    'hidden' => array(
      'facet_id' => $facet->facet_id,
      'type'     => 'field',
    ),
    'select' => array(
      'attribute_set_id' => array(),
      'name' => array(),
    ),
  );
  $sql = "SELECT set_id, name, description FROM {xc_search_field_facet_properties}";
  $result = db_query(db_rewrite_sql($sql, '{xc_search_field_facet_properties}',
    'set_id'));
  while ($data = db_fetch_object($result)) {
    $options['select']['attribute_set_id'][$data->set_id] =  $data->name;
  }
  $options['select']['name'] = array_merge(
    xc_search_facet_mapping_get_facets($facet->metadata_schema),
    xc_format_get_fields($facet->metadata_schema)
  );
  
  $form = xc_util_build_autoform($schema, $options);
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
  );

  return $form;
}

function xc_search_facet_field_edit_form($form_state, $record) {
  $facet = xc_search_facet_load($record->facet_id);
  $form = xc_search_facet_field_form($form_stat, $facet);
  $form['field_id'] = array(
    '#type'  => 'hidden',
    '#value' => $record->field_id,
  );
  foreach (xc_search_facet_field_fieldset() as $name => $label) {
    $form[$name]['#default_value'] = $field->$name;
  }

  $form['submit']['#value'] = t('Save');
  $form['delete'] = array(
    '#type' => 'submit',
    '#value' => t('Delete'),
  );

  return $form;
}

function xc_search_facet_field_form_submit($form, &$form_state) {
  $values = $form_state['values'];
  $record = new stdClass();
  foreach (xc_search_facet_field_fieldset() as $name => $label) {
    $record->$name = $values[$name];
  }
  $ret_val = drupal_write_record('xc_search_facet_field', $record);
  if ($ret_val == SAVED_NEW) {
    drupal_set_message(t('Successfully added facet field "%name"',
                         array('%name' => $record->name)));
    $form_state['redirect'] = 'xc/search/displaying/facet/' . $record->facet_id . '/view';
  }
  else {
    drupal_set_message(t('Unexpected error. Failed to create new facet field.'));
  }
}

function xc_search_facet_field_edit_form_submit($form, &$form_state) {
  $values = $form_state['values'];
  $record = new stdClass();
  $record->field_id         = $values['field_id'];
  foreach (xc_search_facet_field_fieldset() as $name => $label) {
    $record->$name = $values[$name];
  }
  if ($form_state['clicked_button']['#value'] == t('Delete')) {
    $sql = "DELETE FROM {xc_search_facet_field} WHERE field_id = %d";
    $result = db_query(db_rewrite_sql($sql, '{xc_search_facet_field}', 'field_id'), 
      $record->field_id);

    if ($result == SAVED_DELETED) { // facet field is deleted
      drupal_set_message(t('%name removed', array('%name' => $record->name)));
      $form_state['redirect'] = 'xc/search/displaying/facet/' . $record->facet_id . '/view';
    }
    else {
      drupal_set_message(t('Unexpected error. Failed to remove repository.'));
    }
  }
  else {
    $ret_val = drupal_write_record('xc_search_facet_field', $record, 'field_id');
    if ($ret_val == SAVED_UPDATED) {
      drupal_set_message(t('Successfully updated facet field "%name"',
        array('%name' => $record->name)));
      $form_state['redirect'] = 'xc/search/displaying/facet/' . $record->facet_id . '/view';
    }
    else {
      drupal_set_message(t('Unexpected error. Failed to create new facet.'));
    }
  }
}

function xc_search_facet_field_remove($field) {
  $sql = "DELETE FROM {xc_search_facet_field} WHERE field_id = %d";
  $result = db_query(db_rewrite_sql($sql, '{xc_search_facet_field}', 'field_id'), $field->field_id);
  if ($result == SAVED_DELETED) { // repository is deleted
    drupal_set_message(t('%name removed', array('%name' => $field->name)));
    drupal_goto('xc/search/displaying/facet/' . $field->facet_id . '/view');
  }
  else {
    drupal_set_message(t('Unexpected error. Failed to remove facet field.'));
  }
}

